            LIST      P=16F84, F=INHX8M
            include "P16F84.inc"

Drehzahl		equ	0x1D	
Temp			equ	0x0C
AUS			equ	0x1C
MAX			equ	0x21
TEXT_ON			equ	0x1F
Zhl			equ	0x1E
Pause			equ     0x06	;Laufschrift 0x06, Umschalten 0x30
Warte			equ	0x20

Reset       ORG     0x0000			;Resetvektor

	    GOTO	Start

;kleiner Text fuer HEX-File-Leser

            DT		"JETCONTROL V0.9 (02.05.2001) by SSV <s.stoecker@gmx.de>"

;schreibt den Text im LCD-Modul

LCD_TEXT    MOVLW   0x80			;Zeile 1 setzen		
            CALL    LCD_CMD
            MOVLW   0x00			;1.
naechste	MOVWF	Temp			
		CALL	TEXT			;Zeichen holen (in W)
		CALL	LCD_ZEICHEN		;ausgeben
		MOVLW	0x4F			;80. Zeichen gewesen? =80-1           
		SUBWF	Temp,W
		BTFSC	STATUS,C		;dann
		RETURN				;zurueck
		MOVF	Temp	, W		;nocheins
		ADDLW	0x01			
		GOTO	naechste


TEXT 	    ADDWF   PCL       , f
            DT   " JETCONTROL V0.9 s.stoecker@gmx.de",2,3,4,5,6,7
            DT   "ROL V0.9 s.stoecker@gmx.de",2,3,4,5,6,7," JETCONT"
	    DT		0
 

Start	    CLRF    MAX
            CLRF    STATUS
            CLRF    INTCON
            BSF     STATUS    , RP0
            CLRF    TRISA
            MOVLW   0xF0
            MOVWF   TRISB
            BSF     OPTION_REG, NOT_RBPU
            BCF     STATUS    , RP0
            CLRF    PORTA
            CLRF    PORTB
            CALL    LCD_INI				
            CALL    LCD_Sonder
            CLRF    TEXT_ON

Anfang      CLRF    INTCON
            BSF     STATUS    , RP0
            BSF     OPTION_REG, T0CS
            BSF     TRISA     , 04
            BCF     STATUS    , RP0
            MOVLW   0x61

;warten auf L an PortA,4

            MOVWF   Drehzahl

Loop1	    CLRF    Zhl

Loop2	    BTFSS   PORTA     , 04
            GOTO    TestH
            DECFSZ  Zhl      , f
            GOTO    Loop2
            DECFSZ  Drehzahl      , f
            GOTO    Loop1
            GOTO    Anz_TXT

;warten auf H an PortA,4

TestH	    MOVLW   0x61
            MOVWF   Drehzahl

Loop3       CLRF    Zhl

Loop4       BTFSC   PORTA     , 04
            GOTO    Messen
            DECFSZ  Zhl      , f
            GOTO    Loop4
            DECFSZ  Drehzahl      , f
            GOTO    Loop3
            GOTO    Anz_TXT

Messen      CLRF    TMR0
            MOVLW   0x61
            MOVWF   Drehzahl

Loop5       CLRF    Zhl

Loop6       DECFSZ  Zhl      , f
            GOTO    Loop6
            DECFSZ  Drehzahl      , f
            GOTO    Loop5
            MOVLW   0x10
            MOVWF   Zhl

Loop7       DECFSZ  Zhl      , f
            GOTO    Loop7
            MOVF    TMR0      , W		;Drehzahl sichern
            MOVWF   Drehzahl
            MOVF    TEXT_ON      , W		;Text an?
            BTFSC   STATUS    , Z
            GOTO    TEST_MAX			
            MOVF    Drehzahl      , f		
            BTFSC   STATUS    , Z
            GOTO    Anz_TXT			;alternative Anzeige
            CALL    LCD_RET			;Rcksetzen nach Text

TEST_MAX    MOVLW   0x20			;ausreichend Drehzahl
            SUBWF   Drehzahl      , f
            BTFSS   STATUS    , C
            GOTO    Label_0014
            ADDWF   Drehzahl      , f
            MOVF    Drehzahl      , W
            SUBWF   MAX      , f
            BTFSC   STATUS    , C
            GOTO    Label_0015
            MOVWF   MAX
            GOTO    DREH_ANZ

Label_0015  ADDWF   MAX      , f
            GOTO    DREH_ANZ

Label_0014  ADDWF   Drehzahl      , f

DREH_ANZ    CALL    LCD_DREH
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CALL    Warten3
            CLRF    TEXT_ON
            GOTO    Anfang

Anz_TXT     BTFSC   PORTB,4		;Teste Port B4 
            CLRF    MAX			;kein MAX

	    MOVF    MAX      , W	;MAX-Wert gesetzt?
            BTFSS   STATUS    , Z

            GOTO    LCD_MAX		;anzeigen von max!
            ;NOP			;oder keine max-Anzeige

	    MOVF    TEXT_ON      , f
            BTFSS   STATUS    , Z
            GOTO    Label_001B
            CALL    LCD_TEXT
            MOVLW   Pause
            MOVWF   Warte
            INCF    TEXT_ON      , f

Label_001B  DECF    Warte      , f
            BTFSC   STATUS    , Z
            GOTO    Label_001D
            GOTO    Anfang

Label_001D  MOVLW   Pause
            MOVWF   Warte
            MOVLW   0x18
            CALL    LCD_CMD		;1x bei Laufschrift
            ;MOVLW   0x18
            ;CALL    LCD_CMD		;8x bei Umschalttext
            ;MOVLW   0x18
            ;CALL    LCD_CMD		
            ;MOVLW   0x18
            ;CALL    LCD_CMD		
            ;MOVLW   0x18
            ;CALL    LCD_CMD		
            ;MOVLW   0x18
            ;CALL    LCD_CMD		
            ;MOVLW   0x18
            ;CALL    LCD_CMD		
            ;MOVLW   0x18
            ;CALL    LCD_CMD		
	    GOTO    Anfang

LCD_ZEICHEN	MOVWF   0x0E
            CALL    Label_001E
            MOVLW   0xF0
            ANDWF   PORTB     , f
            SWAPF   0x0E      , W
            ANDLW   0x0F
            IORWF   PORTB     , f
            BCF     PORTA     , 02
            BSF     PORTA     , 01
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            MOVLW   0xF0
            ANDWF   PORTB     , f
            MOVF    0x0E      , W
            ANDLW   0x0F
            IORWF   PORTB     , f
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            RETURN

LCD_CMD	    MOVWF   0x0E
            CALL    Label_001E
            BSF     STATUS    , RP0
            MOVLW   0x00
            IORWF   TRISB     , W
            MOVWF   TRISB
            BCF     STATUS    , RP0
            MOVLW   0xF0
            ANDWF   PORTB     , f
            SWAPF   0x0E      , W
            ANDLW   0x0F
            IORWF   PORTB     , f
            BCF     PORTA     , 02
            BCF     PORTA     , 01
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            MOVLW   0xF0
            ANDWF   PORTB     , f
            MOVF    0x0E      , W
            ANDLW   0x0F
            IORWF   PORTB     , f
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            RETURN

Label_001E  CALL    Warten2
            RETURN
            BSF     STATUS    , RP0
            MOVLW   0x0F
            IORWF   TRISB     , W
            MOVWF   TRISB
            BCF     STATUS    , RP0
            BCF     PORTA     , 01
            BSF     PORTA     , 02
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            SWAPF   PORTB     , W
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            BTFSC   0x0D      , 07
            GOTO    Label_001E
            BCF     PORTA     , 02
            BSF     STATUS    , RP0
            MOVLW   0xF0
            ANDWF   TRISB     , W
            MOVWF   TRISB
            BCF     STATUS    , RP0
            RETURN

;Initialisieren des LCD-Modules

LCD_INI     CALL    Warten1
            CALL    Warten1
	    BCF     PORTA     , 03
            BCF     PORTA     , 01
            BCF     PORTA     , 02
            CALL    Warten3
            CALL    Warten3
            MOVLW   0x03
            MOVWF   PORTB
            BSF     STATUS    , RP0
            MOVLW   0xF0
            ANDWF   TRISB     , W
            MOVWF   TRISB
            BCF     STATUS    , RP0
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            CALL    Warten1
            CALL    Warten1
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            CALL    Warten2
            CALL    Warten2
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            CALL    Label_001E
            MOVLW   0x02
            MOVWF   PORTB
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            MOVLW   0x28
            CALL    LCD_CMD
            MOVLW   0x08
            CALL    LCD_CMD
            MOVLW   0x0C
            CALL    LCD_CMD
            MOVLW   0x06
            CALL    LCD_CMD
            RETURN

Warten1	MOVLW   0xFC
            MOVWF   0x0F
            MOVLW   0x04
            MOVWF   0x10
            MOVLW   0x01
            MOVWF   0x11
            MOVLW   0x01
            MOVWF   0x12

Loop        NOP
            DECFSZ  0x0F      , f
            GOTO    Loop
            DECFSZ  0x10      , f
            GOTO    Loop
            DECFSZ  0x11      , f
            GOTO    Loop
            DECFSZ  0x12      , f
            GOTO    Loop
            RETURN

Warten2	    MOVLW   0x16
            MOVWF   0x0F
            MOVLW   0x01
            MOVWF   0x10
            MOVLW   0x01
            MOVWF   0x11
            MOVLW   0x01
            MOVWF   0x12
            GOTO    Loop

Warten3	    MOVLW   0x9C
            MOVWF   0x0F
            MOVLW   0x15
            MOVWF   0x10
            MOVLW   0x01
            MOVWF   0x11
            MOVLW   0x01
            MOVWF   0x12
            GOTO    Loop

LCD_RET     MOVLW   0x01
            CALL    LCD_CMD
            CALL    Warten1
            RETURN

;erzeugen der SonderLCD_ZEICHEN

LCD_Sonder  MOVLW   0x40				;LCD_ZEICHEN_Ram auf 0 setzen			
            CALL    LCD_CMD

            MOVLW   0x11				;LCD_ZEICHEN 0, das ist ein ""
            CALL    LCD_ZEICHEN
            MOVLW   0x00
		CALL    LCD_ZEICHEN
            MOVLW   0x11
		CALL    LCD_ZEICHEN
            MOVLW   0x11
		CALL    LCD_ZEICHEN
            MOVLW   0x11
		CALL    LCD_ZEICHEN
            MOVLW   0x11
		CALL    LCD_ZEICHEN
            MOVLW   0x0e
		CALL    LCD_ZEICHEN
            MOVLW   0x00
		CALL    LCD_ZEICHEN

            MOVLW   0x11			;LCD_ZEICHEN 1, ein 
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x0e
            CALL    LCD_ZEICHEN
            MOVLW   0x11
            CALL    LCD_ZEICHEN
            MOVLW   0x11
            CALL    LCD_ZEICHEN
            MOVLW   0x11
            CALL    LCD_ZEICHEN
            MOVLW   0x0E
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN

            MOVLW   0x00			;LCD_ZEICHEN 2
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x03
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x03
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN

            MOVLW   0x00			;LCD_ZEICHEN 3
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x07
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN

            MOVLW   0x00			;LCD_ZEICHEN 4
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x1C
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN

            MOVLW   0x00			;LCD_ZEICHEN 5
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN

            MOVLW   0x00			;LCD_ZEICHEN 6
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x03
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x1F
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN

            MOVLW   0x06			;LCD_ZEICHEN 7
            CALL    LCD_ZEICHEN
            MOVLW   0x1E
            CALL    LCD_ZEICHEN
            MOVLW   0x3E
            CALL    LCD_ZEICHEN
            MOVLW   0x3F
            CALL    LCD_ZEICHEN
            MOVLW   0x3F
            CALL    LCD_ZEICHEN
            MOVLW   0x3C
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            MOVLW   0x00
            CALL    LCD_ZEICHEN
            RETURN

;Anzeige der Drehzahl

LCD_DREH    MOVLW   0x80			;Zeile 1
            CALL    LCD_CMD
            MOVLW   0x20
            CALL    LCD_ZEICHEN			;" "
            MOVLW   0x20
            CALL    LCD_ZEICHEN			;" "

Z100	    MOVLW   0x64			;100->W
            SUBWF   Drehzahl      , f		
            BTFSS   STATUS    , C		;zuviel?
            GOTO    A100
            INCF    Zhl      , f		
            GOTO    Z100

A100	    MOVLW   0x64
            ADDWF   Drehzahl      , f
            MOVF    Zhl      , W
            BCF     AUS      , 00
            BTFSC   STATUS    , Z
            BSF     AUS      , 00
            MOVLW   0x30
            ADDWF   Zhl      , W
            BTFSC   AUS      , 00
            MOVLW   0x20
            CALL    LCD_ZEICHEN
            CLRF    Zhl

Label_0025  MOVLW   0x0A
            SUBWF   Drehzahl      , f
            BTFSS   STATUS    , C
            GOTO    Label_0024
            INCF    Zhl      , f
            GOTO    Label_0025

Label_0024  MOVLW   0x0A
            ADDWF   Drehzahl      , f
            BTFSS   AUS      , 00
            GOTO    Label_0026
            MOVF    Zhl      , W
            BTFSS   STATUS    , Z
            BCF     AUS      , 00

Label_0026  MOVLW   0x30
            ADDWF   Zhl      , W
            BTFSC   AUS      , 00
            MOVLW   0x20
            CALL    LCD_ZEICHEN
            CLRF    Zhl

Label_0028  MOVLW   0x01
            SUBWF   Drehzahl      , f
            BTFSS   STATUS    , C
            GOTO    Label_0027
            INCF    Zhl      , f
            GOTO    Label_0028

Label_0027  MOVLW   0x01
            ADDWF   Drehzahl      , f
            MOVLW   0x30
            ADDWF   Zhl      , W
            CALL    LCD_ZEICHEN
            MOVLW   0x6F
            CALL    LCD_ZEICHEN
            MOVLW   0x6F
            CALL    LCD_ZEICHEN
            MOVLW   0x6F
            CALL    LCD_ZEICHEN
            MOVLW   0xC0
            CALL    LCD_CMD
            MOVLW   0x20
            CALL    LCD_ZEICHEN
            MOVLW   0x55
            CALL    LCD_ZEICHEN
            MOVLW   0x2F
            CALL    LCD_ZEICHEN
            MOVLW   0x6D
            CALL    LCD_ZEICHEN
            MOVLW   0x69
            CALL    LCD_ZEICHEN
            MOVLW   0x6E
            CALL    LCD_ZEICHEN
            MOVLW   0x20
            CALL    LCD_ZEICHEN
            MOVLW   0x20
            CALL    LCD_ZEICHEN
            RETURN


LCD_MAX	    MOVF    MAX      , W			
            MOVWF   Drehzahl
            CALL    LCD_DREH
            GOTO    Anfang



            END
